#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "gps.h"
#include "ins.h"
#include "position.h"
#include "kalman.h"
#include "initialize.h"
#include "accl.h"

#define time_delay 0
#define GPS_PORT 6
#define INS_PORT 8
#define ACCL_PORT 1

GPS prev_gps;
INS prev_ins;
KALMAN prev_kalman_data;
KALMAN kalman_data;
GPS gps;
INS ins;
INITIAL init_data;
ACCL accl_data;

MATRIX X_est_mat(parameters*2,1);
MATRIX X_pred_mat(parameters*2,1);
MATRIX Innov_mat(parameters,1);
MATRIX W_mat(parameters*2,parameters);
MATRIX P_est_mat(parameters*2,parameters*2);
MATRIX P_pred_mat(parameters*2,parameters*2);
MATRIX S_mat(parameters,parameters);
MATRIX H_mat(parameters,parameters*2);
MATRIX G_mat(parameters*2,parameters);
MATRIX F_mat(parameters*2,parameters*2);
MATRIX X_mat(parameters*2,1);
MATRIX Z_mat(parameters,1);

MATRIX prev_X_est_mat(parameters*2,1);
MATRIX prev_X_pred_mat(parameters*2,1);
MATRIX prev_Innov_mat(parameters,1);
MATRIX prev_W_mat(parameters*2,parameters);
MATRIX prev_P_est_mat(parameters*2,parameters*2);
MATRIX prev_P_pred_mat(parameters*2,parameters*2);
MATRIX prev_S_mat(parameters,parameters);
MATRIX prev_H_mat(parameters,parameters*2);
MATRIX prev_G_mat(parameters*2,parameters);
MATRIX prev_F_mat(parameters*2,parameters*2);
MATRIX prev_X_mat(parameters*2,1);
MATRIX prev_Z_mat(parameters,1);

SYSTEMTIME ntime,ptime;

void clear_files();
void print_data();
void copy();

int main()
{ 
  char mode;
  int init=1;
  DWORD sec=time_delay;

  clear_files();

  accl_open_serial(ACCL_PORT);
  ins_open_serial(INS_PORT);
  //gps_open_serial(GPS_PORT);
  mode=ins_config();
  if(mode=='e')
  {
	  printf("Ins not connected\n");
	  getchar();
  }
  
  while(1)
  {
	  Sleep(sec);
	  //GetSystemTime(&ntime);
      //gps_read();
	  ins_read(mode);
	  
	  /*if(init==1)
	  {
		//init_data.initialize();
		  {
			  prev_kalman_data.calc_pos_variables();
		      prev_P_est_mat.unit();
		      prev_P_est_mat=prev_P_est_mat.operator *(Q_VAL*10);
		  }
		prev_gps=gps;
		prev_ins=ins;
		ptime=ntime;
		init=0;
		continue;
	  }*/
	  //kalman();
	  //ptime=ntime;
	  //copy();
	  //print_data();
  }

  //CloseHandle(ins_handle);
  //CloseHandle(gps_handle);
  getchar();
  return 0;
}

void clear_files()
{
  FILE *fp;
  fp=fopen("accl.txt","w");
  fclose(fp);
  fp=fopen("time.txt","w");
  fclose(fp);
  fp=fopen("ins_log.txt","w");
  fclose(fp);
  fp=fopen("ins_data.txt","w");
  fclose(fp);
  fp=fopen("gps_data.txt","w");
  fclose(fp);
  fp=fopen("gps_log.txt","w");
  fclose(fp);
  fp=fopen("kalman_gps_data.txt","w");
  fclose(fp);
  fp=fopen("kalman_ins_data.txt","w");
  fclose(fp);
  fp=fopen("kalman_log.txt","w");
  fclose(fp);
}

void copy()
{
	prev_gps=gps;
	prev_ins=ins;
	prev_kalman_data=kalman_data;

	prev_X_est_mat = X_est_mat;
	prev_X_pred_mat = X_pred_mat;
	prev_Innov_mat = Innov_mat;
	prev_W_mat = W_mat;
	prev_P_est_mat = P_est_mat;
	prev_P_pred_mat = P_pred_mat;
	prev_S_mat = S_mat;
	prev_H_mat = H_mat;
	prev_G_mat = G_mat;
	prev_F_mat = F_mat;
	prev_X_mat = X_mat;
	prev_Z_mat = Z_mat;
}

void print_data()
{
	//FILE *fp2,*fp3;
	//fp1=fopen("kalman_gps_data.txt","a");
	//fp2=fopen("kalman_ins_data.txt","a");
	//fp3=fopen("kalman_log.txt","a");

	X_mat.print_file_mat();
	Z_mat.print_file_mat();
	X_est_mat.print_file_mat();
	X_pred_mat.print_file_mat();
	P_est_mat.print_file_mat();
	P_pred_mat.print_file_mat();
	W_mat.print_file_mat();
	S_mat.print_file_mat();
	Innov_mat.print_file_mat();

	//fclose(fp1);
	//fclose(fp2);
	//fclose(fp3);

}