/*	% singapore
	% Latitude: 	1.3667
	% 1 22' 0" N
	% 1 degrees, 22 minutes, 0 seconds North
	% Longitude: 	103.8
	% 103 48' 0" E
	% 103 degrees, 48 minutes, 0 seconds East	*/

#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "gps.h"
#include "ins.h"
#include "position.h"
#include "kalman.h"
#include "initialize.h"

extern GPS prev_gps;
extern INS prev_ins;
extern KALMAN prev_kalman_data;
extern KALMAN kalman_data;
extern GPS gps;
extern INS ins;
extern INITIAL init_data;

extern MATRIX X_est_mat;
extern MATRIX X_pred_mat;
extern MATRIX Innov_mat;
extern MATRIX W_mat;
extern MATRIX P_est_mat;
extern MATRIX P_pred_mat;
extern MATRIX S_mat;
extern MATRIX H_mat;
extern MATRIX G_mat;
extern MATRIX F_mat;
extern MATRIX X_mat;
extern MATRIX Z_mat;

extern MATRIX prev_X_est_mat;
extern MATRIX prev_X_pred_mat;
extern MATRIX prev_Innov_mat;
extern MATRIX prev_W_mat;
extern MATRIX prev_P_est_mat;
extern MATRIX prev_P_pred_mat;
extern MATRIX prev_S_mat;
extern MATRIX prev_H_mat;
extern MATRIX prev_G_mat;
extern MATRIX prev_F_mat;
extern MATRIX prev_X_mat;
extern MATRIX prev_Z_mat;


void INITIAL :: initialize()
{
	char opt_device,opt_latlong,opt_position;
	SYSTEMTIME stime;
	int Hour;

	if(gps.positionFix==1)
	{
		latitude=gps.latitude;
		longitude=gps.longitude;
		altitude=gps.altitude;
		sgt_time=gps.sgtTime;
		lat_sphere=gps.latitudeCardinalString[0];
		long_sphere=gps.longitudeCardinalString[0];
		gps_fix=1;
	}
	else
	{
		GetSystemTime(&stime);
		Hour=(stime.wHour+8>24) ? stime.wHour+8-24 : stime.wHour+8;
		sgt_time=Hour*60*60+stime.wMinute*60+stime.wSecond+stime.wMilliseconds/1000;
reenter_device:
		printf("\nNo GPS fix available do you want to continue with INS only y/n");
		opt_device=_getche();

		switch(opt_device)
		{
		case 'Y':
		case 'y':
reenter_latlong:
			printf("\nDo you want to enter initial position in latitude and longitude y/n");
			opt_latlong=_getche();
			switch(opt_latlong)
			{
			case 'y':
			case 'Y':
				printf("\nEnter latitude : ");
				scanf("%f",&latitude);
				printf("\nEnter longitude : ");
				scanf("%f",&longitude);
				printf("\nEnter altitude");
				scanf("%f",&altitude);
				break;
			case 'n':
			case 'N':
reenter_position:
				printf("\nDo you want to enter the initial position as coordinates y/n");
				opt_position=_getche();
				switch(opt_position)
				{
				case 'y':
				case 'Y':
					printf("\nEnter X position");
					scanf("%f",pos.x);
					printf("\nEnter Y position");
					scanf("%f",pos.y);
					printf("\nEnter Z position");
					break;
				case 'n':
				case'N':
					break;
				default:
					printf("\nInvalid option! Reenter");
					goto reenter_position;
					break;
				}
				break;
			default:
				printf("\nInvalid option! Reenter");
				goto reenter_latlong;
				break;
			}
			break;	
		case 'N':
		case 'n':
			return;
			break;
		default:
			printf("\nInvalid option! Reenter");
			goto reenter_device;
			break;
		}
	}
	accl.x=ins.acclx;
	accl.y=ins.accly;
	accl.z=ins.acclz;

	angle.x=ins.roll_angle;
	angle.y=ins.pitch_angle;
	angle.z=ins.yaw_angle;

	rate.x=ins.roll_rate;
	rate.y=ins.pitch_rate;
	rate.z=ins.yaw_rate;

	prev_kalman_data.dist.x=pos.x;
	prev_kalman_data.dist.y=pos.y;
	prev_kalman_data.dist.z=pos.z;
	prev_kalman_data.calc_pos_variables();
	prev_P_est_mat.unit();
	prev_P_est_mat=prev_P_est_mat.operator *(Q_VAL*10);
}

/*Q=0.2           %Circular error probable 3.3 meter
R=0.1           %Accuracy 3 meters
h_mat=[1 0 0 0 ; 0 0 1 0];
g_mat=[1 0 ; 1 0 ; 0 1 ; 0 1];
x_mat=[xdist' ; xvel' ; ydist' ; yvel'];
z_mat=[xdist' ; ydist'];
x0=zeros(4,1);
p0=eye(4)*Q*10;

lp_est_mat=p0;
f_mat=eye(4);
lp_pred_mat=f_mat*lp_est_mat*f_mat' + g_mat*Q*g_mat';
ls_mat=h_mat*lp_pred_mat*h_mat' + R;
lw_mat=lp_pred_mat*h_mat'/ls_mat;
lp_est_mat=lp_pred_mat - lw_mat*ls_mat*lw_mat';
x_pred_mat(:,1)=f_mat*x0;
innov_mat(:,1)=z_mat(:,1)-h_mat*x_pred_mat(:,1);
x_est_mat(:,1)=x_pred_mat(:,1)+lw_mat*innov_mat(:,1);
% then record the results in columns of output states
p_est_mat(:,:,1)=lp_est_mat;
p_pred_ma(:,:,1)=lp_pred_mat;
w_mat(:,:,1)=lw_mat;
s_mat(:,:,1)=ls_mat;*/