#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include"ins.h"
#define ins_x_bias 0.008690823809524
#define ins_y_bias 0.009368288461538
#define ins_z_bias 0.997780065567734

HANDLE ins_handle;

extern INS ins;



double ins_chksum(byte ins_packet[data_packet_size],int k)
{
	short chsum=0;
	int i;
	for(i=2;i<=21;i++)
	{
		chsum=chsum+ins_packet[i];
	}
	chsum=chsum%0xffff;
	return chsum;
}

void ins_open_serial(int port)
{
   char PORT_INS[12]="\\\\.\\COM";
   char p[3];
   sprintf(p,"%d",port);
   strcat(PORT_INS,p);
   ins_handle = CreateFile(PORT_INS, GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   if (ins_handle == INVALID_HANDLE_VALUE)
   {
       printf("INS Handle Error\n");
   }
   else
   {
       printf("INS Connected to Serial\n");
   }

   DCB dcbS_ins = {0};
   dcbS_ins.DCBlength=sizeof(dcbS_ins);
   if(!GetCommState(ins_handle,&dcbS_ins))
   {
       if(GetLastError()== ERROR_FILE_NOT_FOUND)
       {
           printf("INS Serial Port not found Error\n");
       }
       printf("INS Status Error\n");
   }
   else
   {
       printf("INS Status Received\n");
   }

   dcbS_ins.Parity=0;
   dcbS_ins.ByteSize = 8;//sets bit-size
   dcbS_ins.BaudRate = Baud_Rate_Ins;//sets baudrate

//Sets timeout for reading - 0 = deactivate
   if(!SetCommState(ins_handle,&dcbS_ins))
   {
       printf("INS Serial Parameter Set Error\n");
   }
   else
   {
       printf("INS Serial Parameters Set\n");
   }


   COMMTIMEOUTS timeout_ins ={0};
   timeout_ins.ReadIntervalTimeout=3000;
   timeout_ins.ReadTotalTimeoutConstant=0;
   timeout_ins.ReadTotalTimeoutMultiplier=200;
   timeout_ins.WriteTotalTimeoutConstant=3000;
   timeout_ins.WriteTotalTimeoutMultiplier=200;

   if(!SetCommTimeouts(ins_handle, &timeout_ins))
   {
       printf("INS Timeouts Set Error\n");
   }
   else
   {
       printf("INS Timeouts Set\n");
   }

  //PurgeComm(ins_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
}

void ins_read(char mode)
{
	FILE *fp,*fpn;
	SYSTEMTIME stime;
	int i,chksum,counter=0;
	DWORD number_bytes;
	//char opt;
	fp=fopen("ins_log.txt","a");
	fpn=fopen("time.txt","a");
	byte ins_data_sample[data_packet_size];
	float sgt_time;
	int Hour;
reread:
	if(mode=='P')
	{
		//PurgeComm(ins_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
		if(WriteFile(ins_handle, "P", sizeof("P"), &number_bytes, NULL)==0)
		{
			printf("Ins Polled Mode Serial read error");
		}
		if(WriteFile(ins_handle, "G", sizeof("G"), &number_bytes, NULL)==0)
		{
			printf("Ins Polled Mode Serial read error");
		}
		if(ReadFile(ins_handle, ins_data_sample, data_packet_size, &number_bytes, NULL)==0)
		{
			printf("Ins Polled Mode Serial read error");
		}
		else
		{
			printf("Data Read\n");
			for(i=0;i<data_packet_size;i++)
				printf("ins_data_sample[%02d] = %02x %01c %03d\n",i,ins_data_sample[i],ins_data_sample[i],ins_data_sample[i]);
			for(i=0;i<data_packet_size;i=i+2)
				fprintf(fp,"%02x%02x ",ins_data_sample[i],ins_data_sample[i+1]);
			GetSystemTime(&stime);
			Hour=(stime.wHour+8>24) ? stime.wHour+8-24 : stime.wHour+8;
			sgt_time=(float)Hour*60*60+stime.wMinute*60+stime.wSecond+stime.wMilliseconds/1000;
			fprintf(fp,"\n");
			fprintf(fpn,"%d %d %d %d\n",stime.wHour,stime.wMinute,stime.wSecond,stime.wMilliseconds);
		}
	}

	if(mode=='C')
	{
		//PurgeComm(ins_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
		if(WriteFile(ins_handle, "C", sizeof("C"), &number_bytes, NULL)==0)
		{
			printf("Ins Polled Mode Serial read error");
		}
		if(ReadFile(ins_handle, ins_data_sample, data_packet_size, &number_bytes, NULL)==0)
		{
			printf("Ins Polled Mode Serial read error");
		}
		else
		{
			printf("Data Read\n");
			for(i=0;i<data_packet_size;i++)
				printf("ins_data_sample[%02d] = %02x %01c %03d\n",i,ins_data_sample[i],ins_data_sample[i],ins_data_sample[i]);
			for(i=0;i<data_packet_size;i=i+2)
				fprintf(fp,"%02x%02x ",ins_data_sample[i],ins_data_sample[i+1]);
			fprintf(fp,"\n");
		}
	}

	chksum=ins_data_sample[22]*256+ins_data_sample[23];
	if(chksum>pow(2.0,15.0)-1)
		chksum-=(int)pow(2.0,16.0);
	if(chksum!=ins_chksum(ins_data_sample,0))
	{
		printf("Invalid INS data");
		counter++;
		if(counter>=10)
		{
			printf("No proper incoming INS data");
			//return(ins);
		}
		goto reread;
	}
	ins_info(ins_data_sample,0);

	/*printf("Do you want to continue with polled mode:  p-polled c-continuous q-quit \n");

takeopt:
	opt=_getche();
	switch(opt)
	{
		case 'p':
			goto reread;
			break;
		case 'c':
			mode='C';
			goto reread;
			break;
		case 'q':
			return;
			break;
		default:
			printf("Invalid entry\n");
			goto takeopt;
	}*/

	fclose(fp);
	fclose(fpn);
}

char ins_config()
{
	DWORD number_bytes;
	int i,counter=0;
	unsigned char ins_config_data,ins_version[23],ins_serial[6];
	char mode;
	DWORD sec=zero_bias_delay*1000;
	DWORD tsec=time_constant*1000;
	int seconds=zero_bias_delay;
	int tseconds=time_constant;

	//PurgeComm(ins_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);

	reping:
	if(WriteFile(ins_handle, "R", sizeof("R"), &number_bytes, NULL) == 0)
    {
        printf("Ins Ping Serial Write Error\n");
    }
	if(ReadFile(ins_handle, &ins_config_data, 1, &number_bytes, NULL) == 0)
    {
        printf("Ins Ping Reply Serial Read Error\n");
    }
	else
	{
		//ins_config_data[1]='\0';
		printf("Ping Reply\n");
		printf("%c\n",ins_config_data);
		if(ins_config_data!='H')
		{
			printf("Ping Error: Pinging Again\n");
			if(counter<=10)
			{
				counter++;
				goto reping;
			}
			else
				return 'e';
		}
	}
	if(WriteFile(ins_handle, "v", sizeof("v"), &number_bytes, NULL) == 0)
    {
        printf("Ins Ping Serial Request Write Error\n");
    }
	if(ReadFile(ins_handle, &ins_version, 23, &number_bytes, NULL) == 0)
    {
        printf("Ins Version Reply Read Error\n");
    }
	else
	{
		//ins_config_data[1]='\0';
		printf("Ins Version Reply\n");
		for(i=0;i<23;i++)
				printf("ins_version[%02d] = %02x %01c %03d\n",i,ins_version[i],ins_version[i],ins_version[i]);
	}
	if(WriteFile(ins_handle, "S", sizeof("S"), &number_bytes, NULL) == 0)
    {
        printf("Ins Ping Serial Request Write Error\n");
    }
	if(ReadFile(ins_handle, &ins_serial, 6, &number_bytes, NULL) == 0)
    {
        printf("Ins Serial Reply  Read Error\n");
    }
	else
	{
		//ins_config_data[1]='\0';
		printf("Ins Serial No Reply\n");
		for(i=0;i<6;i++)
				printf("ins_serial[%02d] = %02x %01c %03d\n",i,ins_serial[i],ins_serial[i],ins_serial[i]);
	}

	if(WriteFile(ins_handle, "a", sizeof("a"), &number_bytes, NULL) == 0)
    {
        printf("Ins Angled Mode Write Error\n");
    }
	if(ReadFile(ins_handle, &ins_config_data, 1, &number_bytes, NULL) == 0)
    {
        printf("Ins Angled Mode Serial Read Error\n");
    }
	else
	{
		//ins_config_data[1]='\0';
		printf("Angled Mode Reply\n");
		printf("%c\n",ins_config_data);
	}

	if(WriteFile(ins_handle, "z", sizeof("z"), &number_bytes, NULL) == 0)
    {
        printf("Ins Zero Bias Delay Write Error\n");
    }
	if(WriteFile(ins_handle, &seconds, sizeof(seconds), &number_bytes, NULL) == 0)
    {
        printf("Ins Zero Bias Delay Write Error\n");
    }
	if(ReadFile(ins_handle, &ins_config_data, 1, &number_bytes, NULL) == 0)
    {
        printf("Ins Zero Bias Delay Read Error\n");
    }
	else
	{
		//ins_config_data[1]='\0';
		printf("Zero Bias Delay Reply\n");
		printf("%c\n",ins_config_data);
	}
	if(WriteFile(ins_handle, "T", sizeof("T"), &number_bytes, NULL) == 0)
    {
        printf("Ins Time Constant Delay Write Error\n");
    }
	if(WriteFile(ins_handle, &tseconds, sizeof(tseconds), &number_bytes, NULL) == 0)
    {
        printf("Ins Time Constant Delay Write Error\n");
    }

	printf("INS Configuration Time : %d seconds",seconds+tseconds);
	Sleep(sec+tsec);

	//PurgeComm(ins_handle,PURGE_RXCLEAR|PURGE_TXCLEAR);
	
	mode='P';

	/*printf("Enter Data Aquisition Mode p-polled c-continuous\n");
	
reentry:
	mode=_getche();
	switch(mode)
	{
	   case 'p':
            printf("Ins Polled Mode Selected\n");
			mode='P';
	   break;

	   case 'c':
            printf("Ins Continuous Mode Selected\n");
			mode='C';
			break;

	   default:
		   printf("Invalid entry\n");
		   goto reentry;
	}*/
	return mode;
}
double accl_calc(double accl)
{
	return(accl*(GR*1.5)/pow(2.0,15.0));
}
double rot_calc(double rot)
{
	return(rot*(AR*1.5)/pow(2.0,15.0));
}
double angle_calc(double angle,char type)
{
	switch(type)
	{
	case 'r':
	case 'p':
	    return(angle*SCALE_R_P/pow(2.0,15.0));
		break;
	case 'y':
		return(angle*SCALE_Y/pow(2.0,15.0));
		break;
	default:
		return FALSE;
	}
}

void ins_info(byte ins_packet[data_packet_size],int k)
{
	double acclx,accly,acclz;
	double pitch,roll,yaw;
	double time,temp_voltage,part_no,chkbit;

	FILE *fp;
	fp=fopen("ins_calc.txt","a");

	roll=ins_packet[2]*256+ins_packet[3];
	if(roll>pow(2.0,15.0)-1)
		roll-=pow(2.0,16.0);
	ins.roll_rate=rot_calc(roll);
	ins.roll_angle=angle_calc(roll,'r');

	pitch=ins_packet[4]*256+ins_packet[5];
	if(pitch>pow(2.0,15.0)-1)
		pitch-=pow(2.0,16.0);
	ins.pitch_rate=rot_calc(pitch);
	ins.pitch_angle=angle_calc(pitch,'p');

	yaw=ins_packet[6]*256+ins_packet[7];
	if(yaw>pow(2.0,15.0)-1)
		yaw-=pow(2.0,16.0);
	ins.yaw_rate=rot_calc(yaw);
	ins.yaw_angle=angle_calc(yaw,'y');

	acclx=ins_packet[8]*256+ins_packet[9];
	if(acclx>pow(2.0,15.0)-1)
		acclx-=pow(2.0,16.0);
	ins.acclx=accl_calc(acclx);
	ins.acclx-=ins_x_bias;

	accly=ins_packet[10]*256+ins_packet[11];
	if(accly>pow(2.0,15.0)-1)
		accly-=pow(2.0,16.0);
	ins.accly=accl_calc(accly);
	ins.accly-=ins_y_bias;

	acclz=ins_packet[12]*256+ins_packet[13];
	if(acclz>pow(2.0,15.0)-1)
		acclz-=pow(2.0,16.0);
	ins.acclz=accl_calc(acclz);
	ins.acclz-=ins_z_bias;

	time=ins_packet[14]*256+ins_packet[15];
	if(time>pow(2.0,15.0)-1)
		time-=pow(2.0,16.0);
	ins.time=time;

	temp_voltage=ins_packet[16]*256+ins_packet[17];
	if(temp_voltage>pow(2.0,15.0)-1)
		temp_voltage-=pow(2.0,16.0);
	ins.temp_voltage=temp_voltage;

	part_no=ins_packet[18]*256+ins_packet[19];
	if(part_no>pow(2.0,15.0)-1)
		part_no-=pow(2.0,16.0);
	ins.part_no=part_no;

	chkbit=ins_packet[14]*256+ins_packet[15];
	if(chkbit>pow(2.0,15.0)-1)
		chkbit-=pow(2.0,16.0);
	ins.chkbit=chkbit;

	/*fprintf(fp,"%f %f %f ",ins.roll_rate,ins.pitch_rate,ins.yaw_rate);
	fprintf(fp,"%f %f %f ",ins.roll_angle,ins.pitch_angle,ins.yaw_angle);
	fprintf(fp,"%f %f %f ",ins.acclx,ins.accly,ins.acclz);
	fprintf(fp,"%f %f %f %f\n",ins.time,ins.temp_voltage,ins.part_no,ins.chkbit);*/

	fclose(fp);
}

