#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "kalman.h"
#include "gps.h"
#include "ins.h"
#include "matrix.h"
#include "position.h"

extern GPS prev_gps;
extern INS prev_ins;
extern KALMAN prev_kalman_data;
extern KALMAN kalman_data;
extern GPS gps;
extern INS ins;

extern MATRIX X_est_mat;
extern MATRIX X_pred_mat;
extern MATRIX Innov_mat;
extern MATRIX W_mat;
extern MATRIX P_est_mat;
extern MATRIX P_pred_mat;
extern MATRIX S_mat;
extern MATRIX H_mat;
extern MATRIX G_mat;
extern MATRIX F_mat;
extern MATRIX X_mat;
extern MATRIX Z_mat;

extern MATRIX prev_X_est_mat;
extern MATRIX prev_X_pred_mat;
extern MATRIX prev_Innov_mat;
extern MATRIX prev_W_mat;
extern MATRIX prev_P_est_mat;
extern MATRIX prev_P_pred_mat;
extern MATRIX prev_S_mat;
extern MATRIX prev_H_mat;
extern MATRIX prev_G_mat;
extern MATRIX prev_F_mat;
extern MATRIX prev_X_mat;
extern MATRIX prev_Z_mat;

extern SYSTEMTIME ntime;
extern SYSTEMTIME ptime;
double delta_t;

void kalman()
{	
	double Hour,pHour,sgt_time,prev_sgt_time;
	if(gps.positionFix==1)
		delta_t=gps.sgtTime-prev_gps.sgtTime;
	else
	{
		Hour=(ntime.wHour+8>24) ? ntime.wHour+8-24 : ntime.wHour+8;
		pHour=(ptime.wHour+8>24) ? ptime.wHour+8-24 : ptime.wHour+8;
		sgt_time=Hour*60*60+ntime.wMinute*60+ntime.wSecond+ntime.wMilliseconds/1000;
		prev_sgt_time=pHour*60*60+ptime.wMinute*60+ptime.wSecond+ptime.wMilliseconds/1000;
		delta_t=sgt_time-prev_sgt_time;
	}
	calc_variables();
	kalman_data.calc_pos_variables();
	kalman_mat_init();
	kalman_calc();
}

void calc_variables()
{
	double delta_x,delta_y,delta_z;

	kalman_data.delta_t=delta_t;

	kalman_data.accl.x=ins.acclx;
	kalman_data.accl.y=ins.accly;
	kalman_data.accl.z=ins.acclz;

	kalman_data.vel.x=prev_kalman_data.vel.x+kalman_data.accl.x*delta_t;
	kalman_data.vel.y=prev_kalman_data.vel.y+kalman_data.accl.y*delta_t;
	kalman_data.vel.z=prev_kalman_data.vel.z+kalman_data.accl.z*delta_t;

	if(gps.positionFix==1)
	{
		delta_x=(gps.latitude-prev_gps.latitude)*EARTH_RADIUS;
		delta_y=(gps.longitude-prev_gps.longitude)*EARTH_RADIUS;
		delta_z=(gps.longitude-prev_gps.longitude)*EARTH_RADIUS;
   
		/*kalman_data.vel.x=delta_x/delta_t;
		kalman_data.vel.y=delta_y/delta_t;
		kalman_data.vel.z=delta_z/delta_t;*/
	}
	else
	{
		delta_x=kalman_data.dist.x+kalman_data.vel.x*delta_t;
		delta_y=kalman_data.dist.y+kalman_data.vel.y*delta_t;
		delta_z=kalman_data.dist.z+kalman_data.vel.z*delta_t;
	}

	kalman_data.dist.x=prev_kalman_data.dist.x+delta_x;
	kalman_data.dist.y=prev_kalman_data.dist.y+delta_y;
	kalman_data.dist.z=prev_kalman_data.dist.z+delta_z;
}

void kalman_mat_init()
{
	int i,j;

	//H matrix
	for(i=0,j=0;i<parameters;i++,j+=2)
	{
		H_mat.mat[i][j]=1;
		prev_H_mat.mat[i][j]=1;
	}

	//G matrix
	for(j=0,i=0;j<parameters;j++,i+=2)
	{
		G_mat.mat[i][j]=1;
		G_mat.mat[i+1][j]=1;
		prev_G_mat.mat[i][j]=1;
		prev_G_mat.mat[i+1][j]=1;
	}

	//F matrix
	for(i=0;i<parameters*2;i++)
	{
		for(j=0;j<parameters*2;j++)
		{
			if(i==j)
			{
				F_mat.mat[i][j]=1;
				prev_F_mat.mat[i][j]=1;
				continue;
			}
			F_mat.mat[i][j]=0;
			prev_F_mat.mat[i][j]=0;
		}
	}
}

void kalman_calc()
{
	int i;

	for(i=0;i<parameters*2;i+=2)
	{
		F_mat.mat[i][i+1]=kalman_data.delta_t;
	}

	P_pred_mat = (F_mat.operator *(prev_P_est_mat)*(F_mat.transpose())) + ((G_mat.operator *(G_mat.transpose()))*Q_VAL);
	S_mat = (H_mat.operator *((P_pred_mat.operator *(H_mat.transpose()))))+ R_VAL;
	W_mat = P_pred_mat.operator *(((H_mat.transpose())*(inverse(S_mat))));
	P_est_mat = P_pred_mat.operator -((W_mat. operator *(S_mat)).operator *(W_mat.transpose()));
	X_pred_mat = F_mat.operator *(prev_X_est_mat);
	Innov_mat = Z_mat.operator -(H_mat.operator *(X_pred_mat));
	X_est_mat = X_pred_mat.operator +(W_mat.operator *(Innov_mat));
}
/*delta_time(i)=time(i)-time(i-1);
   f_mat=eye(4);
   f_mat(1,2)=delta_time(i);
   f_mat(3,4)=delta_time(i);
   lp_pred_mat=f_mat*lp_est_mat*f_mat' + g_mat*Q*g_mat';
   ls_mat=h_mat*lp_pred_mat*h_mat' + R;
   lw_mat=lp_pred_mat*h_mat'/ls_mat;
   lp_est_mat=lp_pred_mat - lw_mat*ls_mat*lw_mat';
   x_pred_mat(:,i)=f_mat*x_est_mat(:,i-1);
   innov_mat(:,i)=z_mat(:,i)-h_mat*x_pred_mat(:,i);
   x_est_mat(:,i)=x_pred_mat(:,i) + lw_mat*innov_mat(:,i);
   % then record the results in columns of output states
   p_est_mat(:,:,i)=lp_est_mat;
   p_pred_mat(:,:,i)=lp_pred_mat;
   w_mat(:,:,i)=lw_mat;
   s_mat(:,:,i)=ls_mat;*/

void KALMAN :: calc_pos_variables()
{
	X_mat.mat[0][0]=dist.x;
	X_mat.mat[1][0]=vel.x;
	X_mat.mat[2][0]=dist.y;
	X_mat.mat[3][0]=vel.y;
	X_mat.mat[4][0]=dist.z;
	X_mat.mat[5][0]=vel.z;

	Z_mat.mat[0][0]=dist.x;
	Z_mat.mat[1][0]=dist.y;
	Z_mat.mat[2][0]=dist.z;
}

KALMAN :: KALMAN()
	{
		accl.x=0.0;
		accl.y=0.0;
		accl.z=0.0;
		vel.x=0.0;
		vel.y=0.0;
		vel.z=0.0;
		dist.x=0.0;
		dist.y=0.0;
		dist.z=0.0;
		angle.x=0.0;
		angle.y=0.0;
		angle.z=0.0;
		rate.x=0.0;
		rate.y=0.0;
		rate.z=0.0;
		/*accl = new xyz;
		vel = new xyz;
		dist = new xyz;
		rate = new xyz;
		angle = new xyz;*/
		delta_t=0.0;

		/*X_est_mat = new MATRIX(parameters*2,1);
		X_pred_mat = new MATRIX(parameters*2,1);
		Innov_mat = new MATRIX(parameters,1);
		W_mat = new MATRIX(parameters*2,parameters);
		P_est_mat = new MATRIX(parameters*2,parameters*2);
		P_pred_mat = new MATRIX(parameters*2,parameters*2);
		S_mat = new MATRIX(parameters,parameters);
		H_mat = new MATRIX(parameters,parameters*2);
		G_mat = new MATRIX(parameters*2,parameters);
		F_mat = new MATRIX(parameters*2,parameters*2);
		X_mat = new MATRIX(parameters*2,1);
		Z_mat = new MATRIX(parameters,1);*/

		//kalman_mat_init();
	}

/*KALMAN :: KALMAN(const KALMAN& K)
	{
		accl.x=K.accl.x;
		accl.y=K.accl.y;
		accl.z=K.accl.z;
		vel.x=K.vel.x;
		vel.y=K.vel.y;
		vel.z=K.vel.z;
		dist.x=K.dist.x;
		dist.y=K.dist.x;
		dist.z=K.dist.x;
		angle.x=K.angle.x;
		angle.y=K.angle.y;
		angle.z=K.angle.z;
		rate.x=K.rate.x;
		rate.y=K.rate.y;
		rate.z=K.rate.z;

		accl = new xyz;
		vel = new xyz;
		dist = new xyz;
		rate = new xyz;
		angle = new xyz;

		delta_t=K.delta_t;
		int i=0;
		int j=0;

		X_est_mat->rows=K.X_est_mat->rows;
		X_est_mat->cols=K.X_est_mat->cols;
		X_pred_mat->rows=K.X_pred_mat->rows;
		X_pred_mat->cols=K.X_pred_mat->cols;
		X_mat->rows=K.X_mat->rows;
		X_mat->cols=K.X_mat->cols;
		P_est_mat->rows=K.X_est_mat->rows;
		P_est_mat->cols=K.X_est_mat->cols;
		P_pred_mat->rows=K.X_pred_mat->rows;
		P_pred_mat->cols=K.X_pred_mat->cols;
		Z_mat->rows=K.X_mat->rows;
		Z_mat->cols=K.X_mat->cols;
		S_mat->rows=K.X_est_mat->rows;
		S_mat->cols=K.X_est_mat->cols;
		W_mat->rows=K.X_pred_mat->rows;
		W_mat->cols=K.X_pred_mat->cols;
		F_mat->rows=K.X_mat->rows;
		F_mat->cols=K.X_mat->cols;
		G_mat->rows=K.X_est_mat->rows;
		G_mat->cols=K.X_est_mat->cols;
		Innov_mat->rows=K.X_pred_mat->rows;
		Innov_mat->cols=K.X_pred_mat->cols;
		H_mat->rows=K.X_mat->rows;
		H_mat->cols=K.X_mat->cols;
		
		for(i=0;i<parameters*2;i++)
		{
			X_est_mat->mat[i][1] = K.X_est_mat->mat[i][1];
			X_pred_mat->mat[i][1] = K.X_pred_mat->mat[i][1];
			X_mat->mat[i][1]=K.X_mat->mat[i][j];
			for(j=0;j<parameters*2;j++)
			{
				P_est_mat->mat[i][j] = K.P_est_mat->mat[i][j];
				P_pred_mat->mat[i][j] = K.P_pred_mat->mat[i][j];
				F_mat->mat[i][j]=K.F_mat->mat[i][j];
				if(j>=parameters)
					continue;
				else
				{		
					W_mat->mat[i][j] = K.W_mat->mat[i][j];
					G_mat->mat[i][j]=K.W_mat->mat[i][j];
				}
			}
		
			if(i>=parameters)
				continue;
			else
			{
				Z_mat->mat[i][1]=K.Z_mat->mat[i][1];
				Innov_mat->mat[i][1]=K.Innov_mat->mat[i][1];
				for(j=0;j<parameters*2;j++)
				{
					H_mat->mat[i][j]=K.H_mat->mat[i][j];
					if(j>=parameters)
						continue;
					else
					{
						S_mat->mat[i][j]=K.S_mat->mat[i][j];
					}
				}
			}
		}
	}*/

KALMAN :: KALMAN(double t)
	{
		/*accl.x=0.0;
		accl.y=0.0;
		accl.z=0.0;
		vel.x=0.0;
		vel.y=0.0;
		vel.z=0.0;
		dist.x=0.0;
		dist.y=0.0;
		dist.z=0.0;
		angle.x=0.0;
		angle.y=0.0;
		angle.z=0.0;
		rate.x=0.0;
		rate.y=0.0;
		rate.z=0.0;*/

		/*accl = new xyz;
		vel = new xyz;
		dist = new xyz;
		rate = new xyz;
		angle = new xyz;*/
		delta_t=t;

		/*X_est_mat = new MATRIX(parameters*2,1);
		X_pred_mat = new MATRIX(parameters*2,1);
		Innov_mat = new MATRIX(parameters,1);
		W_mat = new MATRIX(parameters*2,parameters);
		P_est_mat = new MATRIX(parameters*2,parameters*2);
		P_pred_mat = new MATRIX(parameters*2,parameters*2);
		S_mat = new MATRIX(parameters,parameters);
		H_mat = new MATRIX(parameters,parameters*2);
		G_mat = new MATRIX(parameters*2,parameters);
		F_mat = new MATRIX(parameters*2,parameters*2);
		X_mat = new MATRIX(parameters*2,1);
		Z_mat = new MATRIX(parameters,1);*/

		//kalman_mat_init();
	}
/*KALMAN :: ~KALMAN()
{
		delete X_est_mat;
		delete X_pred_mat;
		delete Innov_mat;
		delete W_mat;
		delete P_est_mat;
		delete P_pred_mat;
		delete S_mat;
		delete H_mat;
		delete G_mat;
		delete F_mat;
		delete X_mat;
		delete Z_mat;
		
		delete accl;
		delete vel;
		delete dist;
}*/