/*	Sensor Fusion using kalman filter
	GPS-INS integration */

#ifndef _kalman_h
#define _kalman_h
#include "gps.h"
#include "ins.h"
#include "position.h"
#include "matrix.h"

#define EARTH_RADIUS 6378.14*1000    //Earth Radius=6378.14 km(approx)
#define Q_VAL 0.2						 //CEP 3.3 metres
#define R_VAL 0.1						 //Accuracy 3 metres
#define parameters 3

class KALMAN
{
public:
	KALMAN();
	KALMAN(const KALMAN& K);
	KALMAN(double t);
	//~KALMAN();
	
	xyz accl;
	xyz vel;
	xyz dist;
	xyz angle;
	xyz rate;
	double delta_t;

		/*MATRIX* X_est_mat;
		MATRIX* X_pred_mat;
		MATRIX* Innov_mat;
		MATRIX* W_mat;
		MATRIX* P_est_mat;
		MATRIX* P_pred_mat;
		MATRIX* S_mat;
		MATRIX* H_mat;
		MATRIX* G_mat;
		MATRIX* F_mat;
		MATRIX* X_mat;
		MATRIX* Z_mat;*/

	void calc_pos_variables();
};

void kalman();
void calc_variables();
void kalman_mat_init();
void kalman_calc();	

#endif









