#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "kalman.h"
#include "matrix.h"


MATRIX MATRIX :: operator *(MATRIX& M)
{
	int i,j,k;
 	if(cols!=M.rows)
	{
		printf("\nmatrix dimension mismatch error");
		getchar();
	}
	MATRIX ANS(rows,M.cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<M.cols;j++)
		{
			for(k=0;k<cols;k++)
			{
				ANS.mat[i][j]+=mat[i][k]*M.mat[k][j];
			}
		}
	}
	return(ANS);
}

MATRIX MATRIX :: operator *(double q)
{	
	int i,j;
	MATRIX ANS(rows,cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			ANS.mat[i][j]=mat[i][j]*q;
		}
	}
	return(ANS);
}


MATRIX MATRIX :: operator +(MATRIX& M)
{
	int i,j;
	if(cols!=M.cols || rows!=M.rows)
	{
		printf("\nmatrix dimension mismatch error");
		getchar();
	}
	MATRIX ANS(rows,cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			ANS.mat[i][j]=mat[i][j]+M.mat[i][j];
		}
	}
	return(ANS);
}

MATRIX MATRIX :: operator +(double r)
{
	int i,j;
	if(rows!=cols)
	{
		printf("\nmatrix dimension mismatch error");
		getchar();
	}
	MATRIX ANS(rows,cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			if(i==j)
			     ANS.mat[i][j]=mat[i][j]+r;
		}
	}
	return(ANS);
}

MATRIX MATRIX :: operator -(MATRIX& M)
{
	int i,j;
	if(cols!=M.cols || rows!=M.rows)
	{
		printf("\nmatrix dimension mismatch error");
		getchar();
	}
	MATRIX ANS(rows,cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			ANS.mat[i][j]=mat[i][j]-M.mat[i][j];
		}
	}
	return(ANS);
}

void MATRIX :: operator =(MATRIX& M)
{
	int i,j;
	if(cols!=M.cols || rows!=M.rows)
	{
		printf("\nmatrix dimension mismatch error");
		getchar();
	}
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			mat[i][j]=M.mat[i][j];
		}
	}
}

MATRIX MATRIX :: transpose()
{
	int i,j;
	MATRIX ANS(cols,rows);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			ANS.mat[j][i]=mat[i][j];
		}
	}
	return(ANS);
}

void MATRIX :: unit()
{
	int i,j;
	if(rows!=cols)
	{
		printf("\nMatrix dimension mismatch error");
		getchar();
	}
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			if(i==j)
			   mat[i][j]=1;
		}
	}
}

MATRIX inverse(MATRIX& M)
{	
	int i,j,k,col1;
	double val,temp;
	MATRIX ANS(M.rows,M.cols);
	
	if(M.rows!=M.cols)
	{
		printf("\nMatrix dimension mismatch error");
		getchar();
	}
	if(M.rows<2)
	{
		printf("\nMatrix dimension less that 2");
		getchar();
	}
	if(determinant(M)==0)
	{
		printf("\nDeterminant=0 Non-Invertble Matrix");
		getchar();
	}
	
	for(i=0;i<M.rows;i++)
	{
		for(j=0;j<M.cols;j++)
		{
			if(i==j)
				ANS.mat[i][j]=1;
			else
				ANS.mat[i][j]=0;
		}
	}
	if(M.mat[0][0]==0)
	{
		for(i=1;i<M.rows;i++)
		{
			if(M.mat[i][0]!=0)
			{
				col1=1;
				for(j=0;j<M.cols;j++)
				{
					temp=M.mat[i][j];
					M.mat[i][j]=M.mat[0][j];
					M.mat[0][j]=temp;

					temp=ANS.mat[i][j];
					ANS.mat[i][j]=ANS.mat[0][j];
					ANS.mat[0][j]=temp;
				}
			}
		}
		if(col1==0)
		{
			printf("\nNon-invertible col1=0");
			getchar();
		}
	}
	for(i=0;i<M.rows;i++)
	{
		val=M.mat[i][i];
		for(j=0;j<M.cols;j++)
		{
			M.mat[i][j]/=val;
			ANS.mat[i][j]/=val;
		}
		for(j=0;j<M.rows;j++)
		{
			if(j==i)    continue;
			val=M.mat[j][i];
			for(k=0;k<M.rows;k++)
			{
				M.mat[j][k]=M.mat[j][k]-val*M.mat[i][k];
				ANS.mat[j][k]=ANS.mat[j][k]-val*ANS.mat[i][k];
			}
		}
	}
	return(ANS);
}

double determinant(MATRIX& M)
{
	int k,i,j,p,q;
	double sum=0,val;
	if(M.rows!=M.cols)
	{
		printf("\nNot a square matrix");
		getchar();
	}
	if(M.rows<2)
	{
		printf("\nMatrix dimension less than 2");
		getchar();
	}
	if(M.rows==2)
		return(M.mat[0][0]*M.mat[1][1]-M.mat[0][1]*M.mat[1][0]);
	else
	{
		MATRIX newM(M.rows-1,M.cols-1);
		for(k=0;k<M.rows;k++)
		{
			p=0;
			q=0;
			for(i=0;i<M.rows;i++)
			{
				if(i==k)   continue;
				for(j=1;j<M.cols;j++)
				{
					newM.mat[p][q]=M.mat[i][j];
					q++;
					if(q==newM.cols)
					{
						q=0;
						p++;
					}
				}
			}
			val=pow(-1.0,k)*M.mat[0][k]*determinant(newM);
			sum+=val;
		}
	}
	return(sum);
}

void MATRIX :: print_file_mat()
{
	int i,j;
	FILE *fp;
	fp=fopen("kalman_gps_data.txt","a");
	fprintf(fp,"%d ",rows);
	fprintf(fp,"%d ",cols);
	for(i=0;i<rows;i++)
	{
		for(j=0;j<cols;j++)
		{
			printf("%f ",mat[i][j]);
			fprintf(fp,"%f ",mat[i][j]);
		}
	}
	printf("\n");
	fprintf(fp,"\n");
	fclose(fp);
}